/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the InstagramUserConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InstagramUserConnectorFormAllOf{}

// InstagramUserConnectorFormAllOf struct for InstagramUserConnectorFormAllOf
type InstagramUserConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Instagram account identifier
	AccountId *string `json:"accountId,omitempty"`
	// Instagram attributes
	Attribute []string `json:"attribute,omitempty"`
	// Date range.
	DateRange *string `json:"dateRange,omitempty"`
}

// NewInstagramUserConnectorFormAllOf instantiates a new InstagramUserConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInstagramUserConnectorFormAllOf() *InstagramUserConnectorFormAllOf {
	this := InstagramUserConnectorFormAllOf{}
	return &this
}

// NewInstagramUserConnectorFormAllOfWithDefaults instantiates a new InstagramUserConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInstagramUserConnectorFormAllOfWithDefaults() *InstagramUserConnectorFormAllOf {
	this := InstagramUserConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *InstagramUserConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *InstagramUserConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *InstagramUserConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *InstagramUserConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *InstagramUserConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *InstagramUserConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *InstagramUserConnectorFormAllOf) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorFormAllOf) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *InstagramUserConnectorFormAllOf) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *InstagramUserConnectorFormAllOf) SetAccountId(v string) {
	o.AccountId = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *InstagramUserConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *InstagramUserConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *InstagramUserConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *InstagramUserConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *InstagramUserConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *InstagramUserConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o InstagramUserConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InstagramUserConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableInstagramUserConnectorFormAllOf struct {
	value *InstagramUserConnectorFormAllOf
	isSet bool
}

func (v NullableInstagramUserConnectorFormAllOf) Get() *InstagramUserConnectorFormAllOf {
	return v.value
}

func (v *NullableInstagramUserConnectorFormAllOf) Set(val *InstagramUserConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableInstagramUserConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableInstagramUserConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInstagramUserConnectorFormAllOf(val *InstagramUserConnectorFormAllOf) *NullableInstagramUserConnectorFormAllOf {
	return &NullableInstagramUserConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableInstagramUserConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInstagramUserConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
